#ifndef RT_GFX_EFFECT_H
#define RT_GFX_EFFECT_H

/* A effect lists the passes during which an object needs to be rendered
 * and a pipeline for each pass.
 * The effect also defines the required vertex layout per pass.
 */

#include "gfx.h"
#include "runtime/resources.h"

typedef struct rt_pipeline_info_s {
    rt_resource_id vertex_shader;
    rt_resource_id fragment_shader;
    rt_resource_id compute_shader;

    /* TODO(Kevin): Fixed function settings */
} rt_pipeline_info;

typedef struct {
    /* Id of the render pass during which this effect pass is run. */
    rt_render_pass_id pass_id;
    rt_resource_id pipeline;
} rt_effect_pass_info;

typedef struct {
    uint32_t pass_count;
    rt_effect_pass_info passes[RT_MAX_SUBRESOURCES];
} rt_effect_info;

#endif
