#ifndef RT_COMMAND_BUFFERS_H
#define RT_COMMAND_BUFFERS_H

#include "gfx/renderer_api.h"
#include "runtime/runtime.h"

#include <volk/volk.h>

void rtResetCommandPools(unsigned int frame_id);

VkCommandBuffer rtGetCommandBuffer(rt_command_buffer_handle cmdbuf);

VkCommandBuffer rtAllocSingleCommandBuffer(rt_gpu_queue queue);

rt_result rtSubmitSingleCommandBuffer(VkCommandBuffer command_buffer,
                                      const VkSemaphore *wait_semaphores,
                                      const uint32_t *wait_values,
                                      uint32_t wait_semaphore_count,
                                      const VkSemaphore *signal_semaphores,
                                      const uint32_t *signal_values,
                                      uint32_t signal_semaphore_count,
                                      rt_gpu_queue queue);

#endif
